searchNodes=[{"doc":"Exile is an alternative for beam ports with back-pressure and non-blocking IO. Quick Start Run a command and read from stdout iex&gt; Exile . stream! ( ~w(echo Hello) ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) # collect as string &quot;Hello \\n &quot; Run a command with list of strings as input iex&gt; Exile . stream! ( ~w(cat) , input : [ &quot;Hello&quot; , &quot; &quot; , &quot;World&quot; ] ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) # collect as string &quot;Hello World&quot; Run a command with input as Stream iex&gt; input_stream = Stream . map ( 1 .. 10 , fn num -&gt; &quot; \#{ num } &quot; end ) iex&gt; Exile . stream! ( ~w(cat) , input : input_stream ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;1 2 3 4 5 6 7 8 9 10 &quot; Run a command with input as infinite stream # create infinite stream iex&gt; input_stream = Stream . repeatedly ( fn -&gt; &quot;A&quot; end ) iex&gt; binary = ...&gt; Exile . stream! ( ~w(cat) , input : input_stream , ignore_epipe : true ) # we need to ignore epipe since we are terminating the program before the input completes ...&gt; |&gt; Stream . take ( 2 ) # we must limit since the input stream is infinite ...&gt; |&gt; Enum . into ( &quot;&quot; ) iex&gt; is_binary ( binary ) true iex&gt; &quot;AAAAA&quot; &lt;&gt; _ = binary Run a command with input Collectable # Exile calls the callback with a sink where the process can push the data iex&gt; Exile . stream! ( ~w(cat) , input : fn sink -&gt; ...&gt; Stream . map ( 1 .. 10 , fn num -&gt; &quot; \#{ num } &quot; end ) ...&gt; |&gt; Stream . into ( sink ) # push to the external process ...&gt; |&gt; Stream . run ( ) ...&gt; end ) ...&gt; |&gt; Stream . take ( 100 ) # we must limit since the input stream is infinite ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;1 2 3 4 5 6 7 8 9 10 &quot; When the command wait for the input stream to close # base64 command wait for the input to close and writes data to stdout at once iex&gt; Exile . stream! ( ~w(base64) , input : [ &quot;abcdef&quot; ] ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;YWJjZGVm \\n &quot; stream!/2 raises non-zero exit as error iex&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo &#39;foo&#39; &amp;&amp; exit 10&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) ** (Exile.Stream.AbnormalExit) program exited with exit status: 10 stream/2 variant returns exit status as last element iex&gt; Exile . stream ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo &#39;foo&#39; &amp;&amp; exit 10&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;foo \\n &quot; , { :exit , { :status , 10 } } # returns exit status of the program as last element ] You can fetch exit_status from the error for stream!/2 iex&gt; try do ...&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;exit 10&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) ...&gt; rescue ...&gt; e in Exile.Stream.AbnormalExit -&gt; ...&gt; e . exit_status ...&gt; end 10 With max_chunk_size set iex&gt; data = ...&gt; Exile . stream! ( ~w(cat /dev/urandom) , max_chunk_size : 100 , ignore_epipe : true ) ...&gt; |&gt; Stream . take ( 5 ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) iex&gt; byte_size ( data ) 500 When input and output run at different rate iex&gt; input_stream = Stream . map ( 1 .. 1000 , fn num -&gt; &quot;X \#{ num } X \\n &quot; end ) iex&gt; Exile . stream! ( ~w(grep 250) , input : input_stream ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;X 250 X \\n &quot; With stderr set to :consume iex&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo foo \\n echo bar &gt;&gt; /dev/stderr&quot; ] , stderr : :consume ) ...&gt; |&gt; Enum . to_list ( ) [ { :stdout , &quot;foo \\n &quot; } , { :stderr , &quot;bar \\n &quot; } ] With stderr set to :disable iex&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo foo \\n echo bar &gt;&gt; /dev/stderr&quot; ] , stderr : :disable ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;foo \\n &quot; ] For more details about stream API, see Exile.stream!/2 and Exile.stream/2 . For more details about inner working, please check Exile.Process documentation.","ref":"Exile.html","title":"Exile","type":"module"},{"doc":"Same as Exile.stream!/2 but the program exit status is passed as last element of the stream. The last element will be of the form {:exit, term()} . term will be a positive integer in case of normal exit and :epipe in case of epipe error See Exile.stream!/2 documentation for details about the options and examples.","ref":"Exile.html#stream/2","title":"Exile.stream/2","type":"function"},{"doc":"Runs the command with arguments and return an the stdout as lazily Enumerable stream, similar to Stream . First parameter must be a list containing command with arguments. Example: [&quot;cat&quot;, &quot;file.txt&quot;] . Options input - Input can be either an Enumerable or a function which accepts Collectable . Enumerable: # List Exile . stream! ( ~w(base64) , input : [ &quot;hello&quot; , &quot;world&quot; ] ) |&gt; Enum . to_list ( ) # Stream Exile . stream! ( ~w(cat) , input : File . stream! ( &quot;log.txt&quot; , [ ] , 65_536 ) ) |&gt; Enum . to_list ( ) Collectable: If the input in a function with arity 1, Exile will call that function with a Collectable as the argument. The function must push input to this collectable. Return value of the function is ignored. Exile . stream! ( ~w(cat) , input : fn sink -&gt; Enum . into ( 1 .. 100 , sink , &amp; to_string / 1 ) end ) |&gt; Enum . to_list ( ) By defaults no input is sent to the command. exit_timeout - Duration to wait for external program to exit after completion (when stream ends). Defaults to :infinity max_chunk_size - Maximum size of iodata chunk emitted by the stream. Chunk size can be less than the max_chunk_size depending on the amount of data available to be read. Defaults to 65_535 stderr - different ways to handle stderr stream. possible values :console , :disable , :stream . :console - stderr output is redirected to console (Default) :disable - stderr output is redirected /dev/null suppressing all output :consume - connects stderr for the consumption. The output stream will contain stderr data along with stdout. Stream data will be either {:stdout, iodata} or {:stderr, iodata} to differentiate different streams. See example below. ignore_epipe - When set to true, reader can exit early without raising error. Typically writer gets EPIPE error on write when program terminate prematurely. With ignore_epipe set to true this error will be ignored. This can be used to match UNIX shell default behaviour. EPIPE is the error raised when the reader finishes the reading and close output pipe before command completes. Defaults to false . Remaining options are passed to Exile.Process.start_link/2 If program exits with non-zero exit status or :epipe then Exile.Stream.AbnormalExit error will be raised with exit_status field set. Examples Exile . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65_535 ) ) |&gt; Stream . into ( File . stream! ( &quot;music.mp3&quot; ) ) |&gt; Stream . run ( ) Stream with stderr Exile . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65_535 ) , stderr : :consume ) |&gt; Stream . transform ( fn -&gt; File . open! ( &quot;music.mp3&quot; , [ :write , :binary ] ) end , fn elem , file -&gt; case elem do { :stdout , data } -&gt; # write stdout data to a file :ok = IO . binwrite ( file , data ) { :stderr , msg } -&gt; # write stderr output to console :ok = IO . write ( msg ) end { [ ] , file } end , fn file -&gt; :ok = File . close ( file ) end ) |&gt; Stream . run ( )","ref":"Exile.html#stream!/2","title":"Exile.stream!/2","type":"function"},{"doc":"","ref":"Exile.html#t:collectable_func/0","title":"Exile.collectable_func/0","type":"type"},{"doc":"GenServer which wraps spawned external command. Use Exile.stream!/1 over using this. Use this only if you are familiar with life-cycle and need more control of the IO streams and OS process. Comparison with Port it is demand driven. User explicitly has to read the command output, and the progress of the external command is controlled using OS pipes. Exile never load more output than we can consume, so we should never experience memory issues it can close stdin while consuming output tries to handle zombie process by attempting to cleanup external process. Note that there is no middleware involved with exile so it is still possible to endup with zombie process. selectively consume stdout and stderr Internally Exile uses non-blocking asynchronous system calls to interact with the external process. It does not use port's message based communication, instead uses raw stdio and NIF. Uses asynchronous system calls for IO. Most of the system calls are non-blocking, so it should not block the beam schedulers. Make use of dirty-schedulers for IO Introduction Exile.Process is a process based wrapper around the external process. It is similar to port as an entity but the interface is different. All communication with the external process must happen via Exile.Process interface. Exile process life-cycle tied to external process and owners. All system resources such are open file-descriptors, external process are cleaned up when the Exile.Process dies. Owner Each Exile.Process has an owner. And it will be the process which created it (via Exile.Process.start_link/2 ). Process owner can not be changed. Owner process will be linked to the Exile.Process . So when the exile process is dies abnormally the owner will be killed too or visa-versa. Owner process should avoid trapping the exit signal, if you want avoid the caller getting killed, create a separate process as owner to run the command and monitor that process. Only owner can get the exit status of the command, using Exile.Process.await_exit/2 . All exile processes MUST be awaited. Exit status or reason is ALWAYS sent to the owner. It is similar to Task . If the owner exit without await_exit , the exile process will be killed, but if the owner continue without await_exit then the exile process will linger around till the process exit. iex&gt; alias Exile.Process iex&gt; { :ok , p } = Process . start_link ( ~w(echo hello) ) iex&gt; Process . read ( p , 100 ) { :ok , &quot;hello \\n &quot; } iex&gt; Process . read ( p , 100 ) # read till we get :eof :eof iex&gt; Process . await_exit ( p ) { :ok , 0 } Pipe &amp; Pipe Owner Standard IO pipes/channels/streams of the external process such as STDIN, STDOUT, STDERR are called as Pipes. User can either write or read data from pipes. Each pipe has an owner process and only that process can write or read from the exile process. By default the process who created the exile process is the owner of all the pipes. Pipe owner can be changed using Exile.Process.change_pipe_owner/3 . Pipe owner is monitored and the pipes are closed automatically when the pipe owner exit. Pipe Owner can close the pipe early using Exile.Process.close_stdin/1 etc. Exile.Process.await_exit/2 closes all of the caller owned pipes by default. iex&gt; { :ok , p } = Process . start_link ( ~w(cat) ) iex&gt; writer = Task . async ( fn -&gt; ...&gt; :ok = Process . change_pipe_owner ( p , :stdin , self ( ) ) ...&gt; Process . write ( p , &quot;Hello World&quot; ) ...&gt; end ) iex&gt; Task . await ( writer ) :ok iex&gt; Process . read ( p , 100 ) { :ok , &quot;Hello World&quot; } iex&gt; Process . await_exit ( p ) { :ok , 0 } Pipe Operations Pipe owner can read or write date to the owned pipe. :stderr by default is connected to console, data written to stderr will appear on the console. You can enable reading stderr by passing stderr: :consume during process creation. Special function Exile.Process.read_any/2 can be used to read from either stdout or stderr whichever has the data available. All Pipe operations blocks the caller to have blocking as natural back-pressure and to make the API simple. This is an important feature of Exile, that is the ability to block caller when the stdio buffer is full, exactly similar to how programs works on the shell with pipes between then cat larg-file | grep &quot;foo&quot; . Internally it does not block the Exile process or VM (which is typically the case with NIF calls). Because of this user can make concurrent read, write to different pipes from separate processes. Internally Exile uses asynchronous IO APIs to avoid blocking of VM or VM process. Reading from stderr # write &quot;Hello&quot; to stdout and &quot;World&quot; to stderr iex&gt; script = Enum . join ( [ &quot;echo Hello&quot; , &quot;echo World &gt;&amp;2&quot; ] , &quot; \\n &quot; ) iex&gt; { :ok , p } = Process . start_link ( [ &quot;sh&quot; , &quot;-c&quot; , script ] , stderr : :consume ) iex&gt; Process . read ( p , 100 ) { :ok , &quot;Hello \\n &quot; } iex&gt; Process . read_stderr ( p , 100 ) { :ok , &quot;World \\n &quot; } iex&gt; Process . await_exit ( p ) { :ok , 0 } Reading using read_any # write &quot;Hello&quot; to stdout and &quot;World&quot; to stderr iex&gt; script = Enum . join ( [ &quot;echo Hello&quot; , &quot;echo World &gt;&amp;2&quot; ] , &quot; \\n &quot; ) iex&gt; { :ok , p } = Process . start_link ( [ &quot;sh&quot; , &quot;-c&quot; , script ] , stderr : :consume ) iex&gt; Process . read_any ( p ) { :ok , { :stdout , &quot;Hello \\n &quot; } } iex&gt; Process . read_any ( p ) { :ok , { :stderr , &quot;World \\n &quot; } } iex&gt; Process . await_exit ( p ) { :ok , 0 } Process Termination When owner does (normally or abnormally) the Exile process always terminated irrespective of pipe status or process status. External process get a chance to terminate gracefully, if that fail it will be killed. If owner calls await_exit then the owner owned pipes are closed and we wait for external process to terminate, if the process already terminated then call returns immediately with exit status. Else command will be attempted to stop gracefully following the exit sequence based on the timeout value (5s by default). If owner calls await_exit with timeout as :infinity then Exile does not attempt to forcefully stop the external command and wait for command to exit on itself. The await_exit call can be blocked indefinitely waiting for external process to terminate. If external process exit on its own, exit status is collected and Exile process will wait for owner to close pipes. Most commands exit with pipes are closed, so just ensuring to close pipes when works is done should be enough. Example of process getting terminated by SIGTERM signal # sleep command does not watch for stdin or stdout, so closing the # pipe does not terminate the sleep command. iex&gt; { :ok , p } = Process . start_link ( ~w(sleep 100000000) ) # sleep indefinitely iex&gt; Process . await_exit ( p , 100 ) # ensure `await_exit` finish within `100ms`. By default it waits for 5s { :ok , 143 } # 143 is the exit status when command exit due to SIGTERM Examples Run a command without any input or output iex&gt; { :ok , p } = Process . start_link ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;exit 1&quot; ] ) iex&gt; Process . await_exit ( p ) { :ok , 1 } Single process reading and writing to the command # bc is a calculator, which reads from stdin and writes output to stdout iex&gt; { :ok , p } = Process . start_link ( ~w(bc) ) iex&gt; Process . write ( p , &quot;1 + 1 \\n &quot; ) # there must be new-line to indicate the end of the input line :ok iex&gt; Process . read ( p ) { :ok , &quot;2 \\n &quot; } iex&gt; Process . write ( p , &quot;2 * 10 + 1 \\n &quot; ) :ok iex&gt; Process . read ( p ) { :ok , &quot;21 \\n &quot; } # We must close stdin to signal the `bc` command that we are done. # since `await_exit` implicitly closes the pipes, in this case we don&#39;t have to iex&gt; Process . await_exit ( p ) { :ok , 0 } Running a command which flush the output on stdin close. This is not supported by Erlang/Elixir ports. # `base64` command reads all input and writes encoded output when stdin is closed. iex&gt; { :ok , p } = Process . start_link ( ~w(base64) ) iex&gt; Process . write ( p , &quot;abcdef&quot; ) :ok iex&gt; Process . close_stdin ( p ) # we can selectively close stdin and read all output :ok iex&gt; Process . read ( p ) { :ok , &quot;YWJjZGVm \\n &quot; } iex&gt; Process . read ( p ) # typically it is better to read till we receive :eof when we are not sure how big the output data size is :eof iex&gt; Process . await_exit ( p ) { :ok , 0 } Read and write to pipes in separate processes iex&gt; { :ok , p } = Process . start_link ( ~w(cat) ) iex&gt; writer = Task . async ( fn -&gt; ...&gt; :ok = Process . change_pipe_owner ( p , :stdin , self ( ) ) ...&gt; Process . write ( p , &quot;Hello World&quot; ) ...&gt; # no need to close the pipe explicitly here. Pipe will be closed automatically when process exit ...&gt; end ) iex&gt; reader = Task . async ( fn -&gt; ...&gt; :ok = Process . change_pipe_owner ( p , :stdout , self ( ) ) ...&gt; Process . read ( p ) ...&gt; end ) iex&gt; :timer . sleep ( 500 ) # wait for the reader and writer to change pipe owner, otherwise `await_exit` will close the pipes before we change pipe owner iex&gt; Process . await_exit ( p , :infinity ) # let the reader and writer take indefinite time to finish { :ok , 0 } iex&gt; Task . await ( writer ) :ok iex&gt; Task . await ( reader ) { :ok , &quot;Hello World&quot; }","ref":"Exile.Process.html","title":"Exile.Process","type":"module"},{"doc":"Wait for the program to terminate and get exit status. ONLY the Process owner can call this function. And all Exile process MUST be awaited (Similar to Task). Exile first politely asks the program to terminate by closing the pipes owned by the process owner (by default process owner is the pipes owner). Most programs terminates when standard pipes are closed. If you have changed the pipe owner to other process, you have to close pipe yourself or wait for the program to exit. If the program fails to terminate within the timeout (default 5s) then the program will be killed using the exit sequence by sending SIGTERM , SIGKILL signals in sequence. When timeout is set to :infinity await_exit wait for the programs to terminate indefinitely. For more details check module documentation.","ref":"Exile.Process.html#await_exit/2","title":"Exile.Process.await_exit/2","type":"function"},{"doc":"Changes the Pipe owner of the pipe to specified pid. Note that currently any process can change the pipe owner. For more details about Pipe Owner, please check module docs.","ref":"Exile.Process.html#change_pipe_owner/3","title":"Exile.Process.change_pipe_owner/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Exile.Process.html#child_spec/1","title":"Exile.Process.child_spec/1","type":"function"},{"doc":"Closes external program's standard error pipe (stderr) Only owner of the pipe can close the pipe. This call will return immediately.","ref":"Exile.Process.html#close_stderr/1","title":"Exile.Process.close_stderr/1","type":"function"},{"doc":"Closes external program's standard input pipe (stdin). Only owner of the pipe can close the pipe. This call will return immediately.","ref":"Exile.Process.html#close_stdin/1","title":"Exile.Process.close_stdin/1","type":"function"},{"doc":"Closes external program's standard output pipe (stdout) Only owner of the pipe can close the pipe. This call will return immediately.","ref":"Exile.Process.html#close_stdout/1","title":"Exile.Process.close_stdout/1","type":"function"},{"doc":"Sends an system signal to external program Note that :sigkill kills the program unconditionally. Avoid sending signals manually, use await_exit instead.","ref":"Exile.Process.html#kill/2","title":"Exile.Process.kill/2","type":"function"},{"doc":"Returns OS pid of the command This is meant only for debugging. Avoid interacting with the external process directly","ref":"Exile.Process.html#os_pid/1","title":"Exile.Process.os_pid/1","type":"function"},{"doc":"Returns bytes from executed command's stdout with maximum size max_size . Blocks if no data present in stdout pipe yet. And returns as soon as data of any size is available. Note that max_size is the maximum size of the returned data. But the returned data can be less than that depending on how the program flush the data etc.","ref":"Exile.Process.html#read/2","title":"Exile.Process.read/2","type":"function"},{"doc":"Returns bytes from either stdout or stderr with maximum size max_size whichever is available at that time. Blocks if no bytes are written to stdout or stderr yet. And returns as soon as data is available. Note that max_size is the maximum size of the returned data. But the returned data can be less than that depending on how the program flush the data etc.","ref":"Exile.Process.html#read_any/2","title":"Exile.Process.read_any/2","type":"function"},{"doc":"Returns bytes from executed command's stderr with maximum size max_size . Pipe must be enabled with stderr: :consume to read the data. Blocks if no bytes are written to stderr yet. And returns as soon as bytes are available Note that max_size is the maximum size of the returned data. But the returned data can be less than that depending on how the program flush the data etc.","ref":"Exile.Process.html#read_stderr/2","title":"Exile.Process.read_stderr/2","type":"function"},{"doc":"Starts Exile.Process server. Starts external program using cmd_with_args with options opts cmd_with_args must be a list containing command with arguments. example: [&quot;cat&quot;, &quot;file.txt&quot;] . Options cd - the directory to run the command in env - a list of tuples containing environment key-value. These can be accessed in the external program stderr - different ways to handle stderr stream. possible values :console , :disable , :stream . :console - stderr output is redirected to console (Default) :disable - stderr output is redirected /dev/null suppressing all output :consume - connects stderr for the consumption. When set to stream the output must be consumed to avoid external program from blocking. Caller of the process will be the owner owner of the Exile Process. And default owner of all opened pipes. Please check module documentation for more details","ref":"Exile.Process.html#start_link/2","title":"Exile.Process.start_link/2","type":"function"},{"doc":"Writes iodata data to external program's standard input pipe. This call blocks when the pipe is full. Returns :ok when the complete data is written.","ref":"Exile.Process.html#write/2","title":"Exile.Process.write/2","type":"function"},{"doc":"","ref":"Exile.Process.html#t:exit_status/0","title":"Exile.Process.exit_status/0","type":"type"},{"doc":"","ref":"Exile.Process.html#t:pipe_name/0","title":"Exile.Process.pipe_name/0","type":"type"},{"doc":"","ref":"Exile.Process.html#t:signal/0","title":"Exile.Process.signal/0","type":"type"},{"doc":"","ref":"Exile.Process.html#t:t/0","title":"Exile.Process.t/0","type":"type"},{"doc":"Defines a Exile.Stream struct returned by Exile.stream!/2 .","ref":"Exile.Stream.html","title":"Exile.Stream","type":"module"},{"doc":"Struct members are private, do not depend on them","ref":"Exile.Stream.html#t:t/0","title":"Exile.Stream.t/0","type":"type"},{"doc":"","ref":"Exile.Process.Error.html","title":"Exile.Process.Error","type":"exception"},{"doc":"","ref":"Exile.Stream.AbnormalExit.html","title":"Exile.Stream.AbnormalExit","type":"exception"},{"doc":"Exile is an alternative to ports for running external programs. It provides back-pressure, non-blocking io, and tries to fix ports issues. Exile is built around the idea of having demand-driven, asynchronous interaction with external process. Think of streaming a video through ffmpeg to serve a web request. Exile internally uses NIF. See Rationale for details. It also provides stream abstraction for interacting with an external program. For example, getting audio out of a stream is as simple as Exile . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65_535 ) ) |&gt; Stream . into ( File . stream! ( &quot;music.mp3&quot; ) ) |&gt; Stream . run ( ) See Exile.stream!/2 module doc for more details about handling stderr and other options. Exile.stream!/2 is a convenience wrapper around Exile.Process . Prefer using Exile.stream! over using Exile.Process directly. Exile requires OTP v22.1 and above. Exile is based on NIF, please know consequence of that before using Exile. For basic use cases use ExCmd instead.","ref":"readme.html","title":"Exile","type":"extras"},{"doc":"def deps do [ { :exile , &quot;~&gt; x.x.x&quot; } ] end","ref":"readme.html#installation","title":"Exile - Installation","type":"extras"},{"doc":"Run a command and read from stdout iex&gt; Exile . stream! ( ~w(echo Hello) ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) # collect as string &quot;Hello \\n &quot; Run a command with list of strings as input iex&gt; Exile . stream! ( ~w(cat) , input : [ &quot;Hello&quot; , &quot; &quot; , &quot;World&quot; ] ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) # collect as string &quot;Hello World&quot; Run a command with input as Stream iex&gt; input_stream = Stream . map ( 1 .. 10 , fn num -&gt; &quot; \#{ num } &quot; end ) iex&gt; Exile . stream! ( ~w(cat) , input : input_stream ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;1 2 3 4 5 6 7 8 9 10 &quot; Run a command with input as infinite stream # create infinite stream iex&gt; input_stream = Stream . repeatedly ( fn -&gt; &quot;A&quot; end ) iex&gt; binary = ...&gt; Exile . stream! ( ~w(cat) , input : input_stream , ignore_epipe : true ) # we need to ignore epipe since we are terminating the program before the input completes ...&gt; |&gt; Stream . take ( 2 ) # we must limit since the input stream is infinite ...&gt; |&gt; Enum . into ( &quot;&quot; ) iex&gt; is_binary ( binary ) true iex&gt; &quot;AAAAA&quot; &lt;&gt; _ = binary Run a command with input Collectable # Exile calls the callback with a sink where the process can push the data iex&gt; Exile . stream! ( ~w(cat) , input : fn sink -&gt; ...&gt; Stream . map ( 1 .. 10 , fn num -&gt; &quot; \#{ num } &quot; end ) ...&gt; |&gt; Stream . into ( sink ) # push to the external process ...&gt; |&gt; Stream . run ( ) ...&gt; end ) ...&gt; |&gt; Stream . take ( 100 ) # we must limit since the input stream is infinite ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;1 2 3 4 5 6 7 8 9 10 &quot; When the command wait for the input stream to close # base64 command wait for the input to close and writes data to stdout at once iex&gt; Exile . stream! ( ~w(base64) , input : [ &quot;abcdef&quot; ] ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;YWJjZGVm \\n &quot; stream!/2 raises non-zero exit as error iex&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo &#39;foo&#39; &amp;&amp; exit 10&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) ** (Exile.Stream.AbnormalExit) program exited with exit status: 10 stream/2 variant returns exit status as last element iex&gt; Exile . stream ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo &#39;foo&#39; &amp;&amp; exit 10&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;foo \\n &quot; , { :exit , { :status , 10 } } # returns exit status of the program as last element ] You can fetch exit_status from the error for stream!/2 iex&gt; try do ...&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;exit 10&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) ...&gt; rescue ...&gt; e in Exile.Stream.AbnormalExit -&gt; ...&gt; e . exit_status ...&gt; end 10 With max_chunk_size set iex&gt; data = ...&gt; Exile . stream! ( ~w(cat /dev/urandom) , max_chunk_size : 100 , ignore_epipe : true ) ...&gt; |&gt; Stream . take ( 5 ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) iex&gt; byte_size ( data ) 500 When input and output run at different rate iex&gt; input_stream = Stream . map ( 1 .. 1000 , fn num -&gt; &quot;X \#{ num } X \\n &quot; end ) iex&gt; Exile . stream! ( ~w(grep 250) , input : input_stream ) ...&gt; |&gt; Enum . into ( &quot;&quot; ) &quot;X 250 X \\n &quot; With stderr set to :consume iex&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo foo \\n echo bar &gt;&gt; /dev/stderr&quot; ] , stderr : :consume ) ...&gt; |&gt; Enum . to_list ( ) [ { :stdout , &quot;foo \\n &quot; } , { :stderr , &quot;bar \\n &quot; } ] With stderr set to :disable iex&gt; Exile . stream! ( [ &quot;sh&quot; , &quot;-c&quot; , &quot;echo foo \\n echo bar &gt;&gt; /dev/stderr&quot; ] , stderr : :disable ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;foo \\n &quot; ] For more details about stream API, see Exile.stream!/2 and Exile.stream/2 . For more details about inner working, please check Exile.Process documentation.","ref":"readme.html#quick-start","title":"Exile - Quick Start","type":"extras"},{"doc":"Existing approaches Port Port is the default way of executing external commands. This is okay when you have control over the external program's implementation and the interaction is minimal. Port has several important issues. it can end up creating zombie process cannot selectively close stdin. This is required when the external programs act on EOF from stdin it sends command output as a message to the beam process. This does not put back pressure on the external program and leads exhausting VM memory Middleware based solutions Libraries such as Porcelain , Erlexec , Rambo , etc. solves the first two issues associated with ports - zombie process and selectively closing STDIN. But not the third issue - having back-pressure. At a high level, these libraries solve port issues by spawning an external middleware program which in turn spawns the program we want to run. Internally uses port for reading the output and writing input. Note that these libraries are solving a different subset of issues and have different functionality, please check the relevant project page for details. no back-pressure additional os process (middleware) for every execution of your program in few cases such as porcelain user has to install this external program explicitly might not be suitable when the program requires constant communication between beam process and external program On the plus side, unlike Exile, bugs in the implementation does not bring down whole beam VM. ExCmd This is my other stab at solving back pressure on the external program issue. It implements a demand-driven protocol using odu to solve this. Since ExCmd is also a port based solution, concerns previously mentioned applies to ExCmd too.","ref":"readme.html#rationale","title":"Exile - Rationale","type":"extras"},{"doc":"Internally Exile uses non-blocking asynchronous system calls to interact with the external process. It does not use port's message based communication instead does raw stdio using NIF. Uses asynchronous system calls for IO. Most of the system calls are non-blocking, so it should not block the beam schedulers. Makes use of dirty-schedulers for IO. Highlights Back pressure no middleware program no additional os process. No performance/resource cost no need to install any external command tries to handle zombie process by attempting to clean up external process. But as there is no middleware involved with exile, so it is still possible to endup with zombie process if program misbehave. stream abstraction selectively consume stdout and stderr streams If you are running executing huge number of external programs concurrently (more than few hundred) you might have to increase open file descriptors limit ( ulimit -n ) Non-blocking io can be used for other interesting things. Such as reading named pipe (FIFO) files. Exile.stream!(~w(cat data.pipe)) does not block schedulers, so you can open hundreds of fifo files unlike default file based io. TODO add benchmarks results 🚨 Obligatory NIF warning As with any NIF based solution, bugs or issues in Exile implementation can bring down the beam VM . But NIF implementation is comparatively small and mostly uses POSIX system calls. Also, spawned external processes are still completely isolated at OS level. If all you want is to run a command with no communication, then just sticking with System.cmd is a better. License Copyright (c) 2020 Akash Hiremath. Exile source code is released under Apache License 2.0. Check LICENSE for more information.","ref":"readme.html#exile","title":"Exile - Exile","type":"extras"},{"doc":"Apache License Version 2.0 , January 2004 http :// www . apache . org / licenses / TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License ; and (b) You must cause any modified files to carry prominent notices stating that You changed the files ; and (c) You must retain, in the Source form of any Derivative Works that You distribute , all copyright , patent , trademark , and attribution notices from the Source form of the Work , excluding those notices that do not pertain to any part of the Derivative Works ; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution , then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file , excluding those notices that do not pertain to any part of the Derivative Works , in at least one of the following places : within a NOTICE text file distributed as part of the Derivative Works ; within the Source form or documentation , if provided along with the Derivative Works ; or , within a display generated by the Derivative Works , if and wherever such third - party notices normally appear . The contents of the NOTICE file are for informational purposes only and do not modify the License . You may add Your own attribution notices within Derivative Works that You distribute , alongside or as an addendum to the NOTICE text from the Work , provided that such additional attribution notices cannot be construed as modifying the License . You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"}]